local OresMoney = CreateFrame("Frame")
OresMoney:RegisterEvent("BAG_UPDATE")
Auctionator.API.InternalVerifyID("Hywolf")


-- icon:Register("MyLDB", myLDB, savedVarTable)
-- icon:Show("MyLDB")

-- Message d'accueil
local prefix = "|cFF8075BATVal:|r"
print(prefix, "Full scan AH with Auctionator and /reload")

local plusBank = false
local details = false
local swapItem = "Mining"

-- Variables
local itemsName = {}
local itemsCount = {}
local itemsUnitPrice = {}
local itemsTotalPrice = {}

local totalPrice = 0

local panelOneHTML_header = "<html><body><p>|cFF8075BAOres|r</p><p><br /></p>" -- par defaut
local panelOneHTML_items = ""
local panelOneHTML_footer = ""
local panelTwoHTML_header = ""
local panelTwoHTML_items = ""
local panelTwoHTML_footer = ""
local panelThreeHTML_header = ""
local panelThreeHTML_items = ""
local panelThreeHTML_footer = ""
local panelFourHTML_header = ""
local panelFourHTML_items = ""
local panelFourHTML_footer = ""

local columnOne, columnTwo, columnThree, columnFour

-- local UIOHMoney
local scrollFrame
local frameInsideScroll
local boxScrollFrame

-- Window SIZE
local smallWidthWindow = 300
local bigWidthWindow = 470
local heightWindow = 280

-- Arrondi
local function round(n)
    return math.floor(n + 0.5)
end

-- ID des items
local mining = {2770, -- copper
2771, -- tin
2775, -- silver
2772, -- iron
2776, -- gold
3858, -- mithril
7911, -- truesilver
10620, -- thorium
23424, -- Fel iron
23425, -- Adamantite
23426, -- Khorium
23427, -- Eternium
2835, -- Rough Stone
2836, -- Coarse Stone
2838, -- Heavy stone
7912 -- Solid Stone
}
local herbalism = {2447, -- Peacebloom
765, -- Silverleaf
2449, 785, 2450, 3820, 2453, 3355, 3369, 3356, 3357, 3818, 3821, 3358, 3819, 4625, 8831, 8836, 8838, 8839, 8845, 8846,
                   13464, 13463, 13465, 13466, 13467, 13468, 22785, 22786, 22787, 22788, 22789, 22790, 22791, 22792,
                   22793}
local cloths = {2589, 2592, 4306, 4338, 14047, 21877, 24272, 21845, 24271}
local skinning = {2934, 2318, 2319, 4234, 8169, 8170, 25708, 25707, 29548, 29539}
local elementals = {7067, 7068, 7069, 7070}
local items = {}

-- Calcul la valeur des items possédés
function RefreshVariablesTotalValue()
    -- On reset
    itemsCount = {}
    itemsUnitPrice = {}
    itemsTotalPrice = {}

    -- On défini les items selon Ores ou Herbs
    items = {}
    if swapItem == "Mining" then
        for key, value in pairs(mining) do
            items[key] = value
        end
    elseif swapItem == "Herbalism" then
        for key, value in pairs(herbalism) do
            items[key] = value
        end
    elseif swapItem == "Cloths" then
        for key, value in pairs(cloths) do
            items[key] = value
        end
    elseif swapItem == "Skinning" then
        for key, value in pairs(skinning) do
            items[key] = value
        end
    elseif swapItem == "Elementals" then
        for key, value in pairs(elementals) do
            items[key] = value
        end
    else
    end

    -- On récupère le nom des items
    itemsName = {}
    for key, value in pairs(items) do
        itemsName[key] = GetItemInfo(value)
    end

    -- On compte les items
    for key, value in pairs(items) do
        itemsCount[key] = GetItemCount(value, plusBank)
    end

    -- On récupère les prix unités depuis Auctionator
    for key, value in pairs(items) do
        itemsUnitPrice[key] = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", value) / 10000
    end

    -- On calcul le prix total de chaque item
    for key, value in pairs(items) do
        itemsTotalPrice[key] = itemsCount[key] * itemsUnitPrice[key]
    end

    -- On calcul le prix total
    totalPrice = 0
    for key, value in pairs(items) do
        totalPrice = totalPrice + itemsTotalPrice[key]
    end
end

local function refreshSize()
    -- SI DETAILS
    if details then
        boxScrollFrame:SetWidth(bigWidthWindow)
    else
        boxScrollFrame:SetWidth(smallWidthWindow)
    end

    columnOne:SetHeight((table.getn(items) * 11) + 30)

    UIOHMoney:SetSize(boxScrollFrame:GetWidth(), heightWindow);
    scrollFrame:SetWidth(boxScrollFrame:GetWidth() - 41);
    frameInsideScroll:SetSize(boxScrollFrame:GetWidth(), columnOne:GetHeight());
end

function RefreshUITotalValue()
    RefreshVariablesTotalValue()
    -- Si UI ouvert
    if UIOHMoney ~= nil then
        refreshSize()

        -- Panel 1
        -- HEADER dans fonction swap
        UIOHMoney.footerOne:SetText('<html><body><p>|cFF00EE66TOTAL VALUE : |r' ..
                                        GetCoinTextureString(totalPrice * 10000, 10) ..
                                        '</p><p><br /></p></body></html>')
        panelOneHTML_header = '<html><body>'
        panelOneHTML_footer = '</body></html>'
        panelOneHTML_items = ''
        for key, value in pairs(items) do
            panelOneHTML_items = panelOneHTML_items .. '<p>' .. itemsName[key] .. '</p>'
        end
        columnOne:SetText(panelOneHTML_header .. panelOneHTML_items .. panelOneHTML_footer);

        -- Si la case DETAILS est cochée, on change la première colonne
        if details then
            UIOHMoney.headerTwo:SetText('<html><body><p>|cFF8075BAQuantity|r</p></body></html>')
            panelTwoHTML_header = '<html><body>'
            panelTwoHTML_footer = '</body></html>'
            panelTwoHTML_items = ''
            for key, value in pairs(items) do
                panelTwoHTML_items = panelTwoHTML_items .. '<p>' .. itemsCount[key] .. '</p>'
            end
            columnTwo:SetText(panelTwoHTML_header .. panelTwoHTML_items .. panelTwoHTML_footer);
        else
            UIOHMoney.headerTwo:SetText('<html><body><p>|cFF8075BATotal price|r</p></body></html>')
            panelTwoHTML_header = '<html><body>'
            panelTwoHTML_footer = '</body></html>'
            panelTwoHTML_items = ''
            for key, value in pairs(items) do
                panelTwoHTML_items = panelTwoHTML_items .. '<p>' ..
                                         GetCoinTextureString(itemsTotalPrice[key] * 10000, 10) .. '</p>'
            end
            columnTwo:SetText(panelTwoHTML_header .. panelTwoHTML_items .. panelTwoHTML_footer);
        end

        -- SI DETAILS, on affiche colonne 3 et 4
        if details then
            -- PANEL 3
            UIOHMoney.headerThree:SetText('<html><body><p>|cFF8075BAUnit price|r</p></body></html>')
            panelThreeHTML_header = '<html><body>'
            panelThreeHTML_footer = '</body></html>'
            panelThreeHTML_items = ''
            for key, value in pairs(items) do
                panelThreeHTML_items = panelThreeHTML_items .. '<p>' ..
                                           GetCoinTextureString(itemsUnitPrice[key] * 10000, 10) .. '</p>'
            end
            columnThree:SetText(panelThreeHTML_header .. panelThreeHTML_items .. panelThreeHTML_footer);

            -- PANEL 4
            UIOHMoney.headerFour:SetText('<html><body><p>|cFF8075BATotal price|r</p></body></html>')
            panelFourHTML_header = '<html><body>'
            panelFourHTML_footer = '</body></html>'
            panelFourHTML_items = ''
            for key, value in pairs(items) do
                panelFourHTML_items = panelFourHTML_items .. '<p>' ..
                                          GetCoinTextureString(itemsTotalPrice[key] * 10000, 10) .. '</p>'
            end
            columnFour:SetText(panelFourHTML_header .. panelFourHTML_items .. panelFourHTML_footer);
        else
            UIOHMoney.headerThree:SetText('')
            UIOHMoney.headerFour:SetText('')
            columnThree:SetText('')
            columnFour:SetText('')
        end

    end
end

-- Lorsque qu'un item est ramassé...
OresMoney:SetScript("OnEvent", function(self, event, ...)
    local arg1, arg2 = ...

    RefreshUITotalValue();
end)

-- SWAP D'ITEMS
local function swap()
    -- Changement de variable
    if swapItem == "Mining" then
        swapItem = "Herbalism"
        UIOHMoney.swapBtn:SetText("Herbalism");
    elseif swapItem == "Herbalism" then
        swapItem = "Cloths"
        UIOHMoney.swapBtn:SetText("Cloths");
    elseif swapItem == "Cloths" then
        swapItem = "Skinning"
        UIOHMoney.swapBtn:SetText("Skinning");
    elseif swapItem == "Skinning" then
        swapItem = "Elementals"
        UIOHMoney.swapBtn:SetText("Elementals");
    elseif swapItem == "Elementals" then
        swapItem = "Mining"
        UIOHMoney.swapBtn:SetText("Mining");
    else
    end

    RefreshUITotalValue()
end

-- A l'ouverture de l'UI
local function createUITotalValue()
    -- On réinitialise les input box
    plusBank = false
    details = false

    -- Création de la fenêtre
    UIOHMoney = CreateFrame("Frame", "OHM_UIOHMoney", UIParent, BackdropTemplateMixin and "BackdropTemplate");
    UIOHMoney:SetMovable(true)
    UIOHMoney:SetBackdrop({
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        edgeSize = 16,
        insets = { left = 4, right = 4, top = 4, bottom = 4 },
    })
    UIOHMoney:SetBackdropColor(0, 0, 0, 1)
    UIOHMoney:EnableMouse(true)
    UIOHMoney:RegisterForDrag("LeftButton")
    UIOHMoney:SetMaxResize(320, 240)
    UIOHMoney:SetResizable(true)
    UIOHMoney:SetScript("OnDragStart", UIOHMoney.StartMoving)
    UIOHMoney:SetScript("OnDragStop", UIOHMoney.StopMovingOrSizing)
    UIOHMoney:SetPoint("CENTER");
    UIOHMoney:SetClampedToScreen(true) -- Empeche de sortir la fenetre de l'écran
    -- UIOHMoney.title = UIOHMoney:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
    -- UIOHMoney.title:SetPoint("LEFT", UIOHMoney.TitleBg, "LEFT", 5, 0);
    -- UIOHMoney.title:SetText(prefix .. " Total value of your resources");
    UIOHMoney:SetClipsChildren(true)

    -- frame qui entoure la scrollframe
    UIOHMoney.boxScrollPart = CreateFrame("Frame", nil, UIOHMoney);
    boxScrollFrame = UIOHMoney.boxScrollPart
    boxScrollFrame:SetSize(smallWidthWindow, 160);
    boxScrollFrame:SetPoint("TOPLEFT", UIOHMoney, "TOPLEFT", 10, -58);
    boxScrollFrame:SetClipsChildren(true)

    -- Scrollframe
    boxScrollFrame.scrollPart = CreateFrame("ScrollFrame", nil, boxScrollFrame, "UIPanelScrollFrameTemplate");
    scrollFrame = boxScrollFrame.scrollPart
    scrollFrame:SetSize(boxScrollFrame:GetWidth() - 40, 160);
    scrollFrame:SetPoint("TOPLEFT", boxScrollFrame, "TOPLEFT", 0, 0);

    -- Frame inside scrollframe
    scrollFrame.scrollchild = UIOHMoney.frameInsideScroll or CreateFrame("Frame")
    frameInsideScroll = scrollFrame.scrollchild
    frameInsideScroll:SetPoint("TOPLEFT", scrollFrame, "TOPLEFT", 0, 0);
    frameInsideScroll:SetSize(boxScrollFrame:GetWidth(), 300);
    scrollFrame:SetScrollChild(frameInsideScroll);
    UIOHMoney:SetSize(frameInsideScroll:GetWidth(), heightWindow);

    -- Colonne 1:
    frameInsideScroll.panelOne = CreateFrame("SimpleHTML", nil, scrollFrame);
    columnOne = frameInsideScroll.panelOne
    columnOne:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE");
    columnOne:SetPoint("TOPLEFT", frameInsideScroll, "TOPLEFT", 0, 0);
    columnOne:SetSize(180, 180);
    columnOne:SetText('<html><body><p>|cFF8075BAHerbs|r</p><p><br /></p></body></html>')
    -- Header colonne 1
    UIOHMoney.headerOne = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.headerOne:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE");
    UIOHMoney.headerOne:SetPoint("TOPLEFT", UIOHMoney, "TOPLEFT", 10, -35);
    UIOHMoney.headerOne:SetSize(180, 20);
    UIOHMoney.headerOne:SetText('<html><body><p>|cFF8075BA|r</p><p><br /></p></body></html>')
    -- Footer colonne 1
    UIOHMoney.footerOne = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.footerOne:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.footerOne:SetPoint("BOTTOMLEFT", UIOHMoney, "BOTTOMLEFT", 10, 35);
    UIOHMoney.footerOne:SetSize(250, 20);
    UIOHMoney.footerOne:SetText('<html><body><p>|cFF00EE66TOTAL VALUE : |r</p><p><br /></p></body></html>')

    -- Colonne 2:
    frameInsideScroll.panelTwo = CreateFrame("SimpleHTML", nil, scrollFrame);
    columnTwo = frameInsideScroll.panelTwo
    columnTwo:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE");
    columnTwo:SetPoint("TOPLEFT", frameInsideScroll, "TOPLEFT", 170, 0);
    columnTwo:SetSize(140, 180);
    -- Header colonne 2
    UIOHMoney.headerTwo = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.headerTwo:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.headerTwo:SetPoint("LEFT", UIOHMoney.headerOne, "LEFT", 170, 0);
    UIOHMoney.headerTwo:SetSize(180, 20);
    UIOHMoney.headerTwo:SetText('<html><body><p>|cFF8075BATITLE|r</p><p><br /></p></body></html>')

    -- Colonne 3:
    frameInsideScroll.panelThree = CreateFrame("SimpleHTML", nil, scrollFrame);
    columnThree = frameInsideScroll.panelThree
    columnThree:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE");
    columnThree:SetPoint("TOPLEFT", frameInsideScroll, "TOPLEFT", 245, 0);
    columnThree:SetSize(140, 180);
    -- Header colonne 3
    UIOHMoney.headerThree = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.headerThree:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.headerThree:SetPoint("LEFT", UIOHMoney.headerTwo, "LEFT", 75, 0);
    UIOHMoney.headerThree:SetSize(180, 20);
    UIOHMoney.headerThree:SetText('<html><body><p>|cFF8075BAUnit price|r</p><p><br /></p></body></html>')

    -- Colonne 4:
    frameInsideScroll.panelFour = CreateFrame("SimpleHTML", nil, scrollFrame);
    columnFour = frameInsideScroll.panelFour
    columnFour:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE");
    columnFour:SetPoint("TOPLEFT", frameInsideScroll, "TOPLEFT", 345, 0);
    columnFour:SetSize(140, 180);
    -- Header colonne 4
    UIOHMoney.headerFour = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.headerFour:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.headerFour:SetPoint("LEFT", UIOHMoney.headerThree, "LEFT", 100, 0);
    UIOHMoney.headerFour:SetSize(180, 20);
    UIOHMoney.headerFour:SetText('<html><body><p>|cFF8075BATotal price|r</p><p><br /></p></body></html>')

    -- Bouton SWAP
    UIOHMoney.swapBtn = CreateFrame("Button", nil, UIOHMoney, "UIPanelButtonTemplate")
    UIOHMoney.swapBtn:SetPoint("TOPLEFT", UIOHMoney, "TOPLEFT", 10, -32);
    UIOHMoney.swapBtn:SetSize(80, 20);
    UIOHMoney.swapBtn:SetText("Mining");
    UIOHMoney.swapBtn:SetScript("OnClick", function()
        swap()
    end)

    -- Check Button bank:
    UIOHMoney.checkBtn1 = CreateFrame("CheckButton", nil, UIOHMoney, "UICheckButtonTemplate");
    UIOHMoney.checkBtn1:SetPoint("BOTTOMLEFT", UIOHMoney, "BOTTOMLEFT", 10, 10);
    UIOHMoney.checkBtn1.text:SetText("+ bank");
    UIOHMoney.checkBtn1.tooltip = "Bank ores/herbs included";
    UIOHMoney.checkBtn1:SetScript("OnClick", function()
        if plusBank then
            plusBank = false
            RefreshUITotalValue()
        else
            plusBank = true
            RefreshUITotalValue()
        end
    end);

    -- Check Button details:
    UIOHMoney.checkBtn2 = CreateFrame("CheckButton", nil, UIOHMoney, "UICheckButtonTemplate");
    UIOHMoney.checkBtn2:SetPoint("LEFT", UIOHMoney.checkBtn1, "LEFT", 80, 0);
    UIOHMoney.checkBtn2.text:SetText("Details");
    UIOHMoney.checkBtn2:SetScript("OnClick", function()
        if details then
            details = false
            RefreshUITotalValue()
        else
            details = true
            RefreshUITotalValue()
        end
    end);

    RefreshUITotalValue();
end

function StartTotalValue()
    RefreshVariablesTotalValue()
    createUITotalValue()
    UIOHMoney:Hide()
    TotalValueLoaded = 1
end
TotalValueLoaded = 0